//----------------------------------------------------------------------------
// DirTree.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: DirTree.pas
//----------------------------------------------------------------------------
#ifndef DirTreeHPP
#define DirTreeHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <FileCtrl.hpp>
#include <ShellAPI.hpp>
#include <ShlObj.hpp>
#include <CommCtrl.hpp>
#include <ComCtrls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Dirtree
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TDirChangeEvent)(System::TObject* Sender,  System::AnsiString ChangedDir
	);

enum TAttribute { daHidden, daSystem };

typedef Set<TAttribute, daHidden, daSystem>  TAttributeSet;

class __declspec(delphiclass) TDirInfo;
class __declspec(pascalimplementation) TDirInfo : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	System::SmallString<255>  Directory;
public:
	/* TObject.Create */ __fastcall TDirInfo(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TDirInfo(void) { }
	
};

class __declspec(delphiclass) ENoValidDir;
class __declspec(pascalimplementation) ENoValidDir : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall ENoValidDir(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall ENoValidDir(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ENoValidDir(int Ident) : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ __fastcall ENoValidDir(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ENoValidDir(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ENoValidDir(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ENoValidDir(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ENoValidDir(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ENoValidDir(void) { }
	
};

class __declspec(delphiclass) TDirTree;
class __declspec(pascalimplementation) TDirTree : public Comctrls::TCustomTreeView
{
	typedef Comctrls::TCustomTreeView inherited;
	
private:
	bool EnableUpdate;
	int DirAttribute;
	System::AnsiString FDirectory;
	bool FOpenDrive;
	bool FOpenDirectory;
	bool FSort;
	TAttributeSet FAttribute;
	TDirChangeEvent FOnDirChange;
	TDirChangeEvent FOnTVChange;
	void __fastcall AutoCreate(void);
	void __fastcall AutoDestroy(void);
	void __fastcall SetDirectory( System::AnsiString Value);
	void __fastcall SetOpenDirectory(bool Value);
	void __fastcall SetOpenDrive(bool Value);
	void __fastcall SetAttribute(TAttributeSet Value);
	void __fastcall SetSort(bool Value);
	System::AnsiString __fastcall GetActiveDirectory(void);
	
protected:
	Comctrls::TTreeNode* __fastcall AddNodeToTree(Comctrls::TTreeNode* Node, bool Child, bool SubDir,  System::AnsiString 
		Path);
	void __fastcall ReadDirectory(Comctrls::TTreeNode* Node);
	void __fastcall CheckForSubDir(Comctrls::TTreeNode* Node);
	virtual void __fastcall Expanding(System::TObject* Sender, Comctrls::TTreeNode* Node, bool &AllowExpansion
		);
	virtual void __fastcall Collapsing(System::TObject* Sender, Comctrls::TTreeNode* Node, bool &AllowCollapse
		);
	void __fastcall UpdateEvent(void);
	
public:
	__fastcall virtual TDirTree(Classes::TComponent* AOwner);
	__fastcall virtual ~TDirTree(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Change(Comctrls::TTreeNode* Node);
	virtual void __fastcall Execute(void);
	Comctrls::TTreeNode* __fastcall WalkTree( System::AnsiString Search, bool CanExpand);
	__property Items ;
	__property TDirChangeEvent OnTVChange = {read=FOnTVChange, write=FOnTVChange};
	
__published:
	__property System::AnsiString Directory = {read=FDirectory, write=SetDirectory, nodefault};
	__property bool OpenDrive = {read=FOpenDrive, write=SetOpenDrive, default=0};
	__property bool OpenDirectory = {read=FOpenDirectory, write=SetOpenDirectory, default=0};
	__property TAttributeSet Attributes = {read=FAttribute, write=SetAttribute, default=0};
	__property bool Sort = {read=FSort, write=SetSort, default=1};
	__property BorderStyle ;
	__property DragCursor ;
	__property ShowLines ;
	__property ShowRoot ;
	__property DragMode ;
	__property Align ;
	__property Enabled ;
	__property Font ;
	__property Color ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property PopupMenu ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property ShowHint ;
	__property Ctl3D ;
	__property Visible ;
	__property TDirChangeEvent OnDirChange = {read=FOnDirChange, write=FOnDirChange};
	__property OnExpanded ;
	__property OnCollapsed ;
	__property OnChanging ;
	__property OnChange ;
	__property OnDeletion ;
	__property OnClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnStartDrag ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property OnDblClick ;
	__property OnKeyDown ;
	__property OnKeyUp ;
	__property OnKeyPress ;
public:
	/* TWinControl.CreateParented */ __fastcall TDirTree(HWND ParentWindow) : Comctrls::TCustomTreeView(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class SmallString<255> ;
template class TAttributeSet ;

}	/* namespace Dirtree */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dirtree;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// DirTree
