//----------------------------------------------------------------------------
// TFileListViewUnit.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: TFileListViewUnit.pas
//----------------------------------------------------------------------------
#ifndef TFileListViewUnitHPP
#define TFileListViewUnitHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <DirTree.hpp>
#include <StdCtrls.hpp>
#include <CommCtrl.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Tfilelistviewunit
{
//-- type declarations -------------------------------------------------------
enum THeader { hdrSize, hdrType, hdrDateTime, hdrAttr };

typedef Set<THeader, hdrSize, hdrAttr>  THeaderType;

enum TFileAttr { ftReadOnly, ftHidden, ftSystem, ftVolumeID, ftDirectory, ftArchive, ftNormal };

typedef Set<TFileAttr, ftReadOnly, ftNormal>  TFileType;

class __declspec(delphiclass) TFileListView;
class __declspec(pascalimplementation) TFileListView : public Comctrls::TCustomListView
{
	typedef Comctrls::TCustomListView inherited;
	
private:
	bool FSortNameAscend;
	bool FSortSizeAscend;
	bool FSortAttrAscend;
	bool FSortDateAscend;
	long FDirFileCount;
	long FDirCount;
	float FDirFileSize;
	bool FDisplaySizeasKB;
	Stdctrls::TLabel* FCaptDirNum;
	Stdctrls::TLabel* FCaptFileNum;
	Stdctrls::TLabel* FCaptFileSize;
	char __fastcall GetDrive(void);
	System::AnsiString __fastcall GetFileName(void);
	void __fastcall MakeColumn(Classes::TAlignment Align,  System::AnsiString Caption, int Width);
	void __fastcall UpdateFilenames(void);
	bool __fastcall IsMaskStored(void);
	void __fastcall SetFileEdit(Stdctrls::TEdit* Value);
	void __fastcall SetDrive(char Value);
	System::AnsiString __fastcall BuildAttrString(const Sysutils::TSearchRec &FileInfoRec);
	System::AnsiString __fastcall BuildDateString(const Sysutils::TSearchRec &FileInfoRec);
	void __fastcall SetFileType(TFileType NewFileType);
	void __fastcall SetFileName(const System::AnsiString NewFile);
	void __fastcall SetDisplaySizeasKB(const bool NewValue);
	void __fastcall GetUpdated(System::TObject* Sender,  System::AnsiString Dir);
	void __fastcall SetHeader(THeaderType Value);
	
protected:
	char FDrive;
	System::AnsiString FDirectory;
	System::AnsiString FMask;
	TFileType FFileType;
	Stdctrls::TEdit* FFileEdit;
	THeaderType FHeader;
	bool FShowFiles;
	Dirtree::TDirTree* FDirTree;
	virtual System::AnsiString __fastcall GetFilePath(void);
	void __fastcall ReadFileNames(void);
	virtual void __fastcall ColClick(Comctrls::TListColumn* Column);
	virtual void __fastcall DblClick(void);
	
public:
	__fastcall virtual TFileListView(Classes::TComponent* AOwner);
	__fastcall virtual ~TFileListView(void);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall ApplyFilePath(const System::AnsiString EditText);
	void __fastcall SetDirectory(const System::AnsiString NewDirectory);
	void __fastcall SetMask(const System::AnsiString NewMask);
	__property char Drive = {read=GetDrive, write=SetDrive, nodefault};
	__property System::AnsiString Directory = {read=FDirectory, write=ApplyFilePath, nodefault};
	__property System::AnsiString FileName = {read=GetFilePath, write=ApplyFilePath, nodefault};
	__property long DirFileCount = {read=FDirFileCount, write=FDirFileCount, nodefault};
	__property long DirCount = {read=FDirCount, write=FDirCount, nodefault};
	__property float DirFileSize = {read=FDirFileSize, write=FDirFileSize, nodefault};
	void __fastcall SetFDirTree(Dirtree::TDirTree* Value);
	void __fastcall SetShowFiles(bool Value);
	
__published:
	__property Align ;
	__property BorderStyle ;
	__property Stdctrls::TLabel* CaptDirNum = {read=FCaptDirNum, write=FCaptDirNum, nodefault};
	__property Stdctrls::TLabel* CaptFileNum = {read=FCaptFileNum, write=FCaptFileNum, nodefault};
	__property Stdctrls::TLabel* CaptFileSize = {read=FCaptFileSize, write=FCaptFileSize, nodefault};
	__property Color ;
	__property ColumnClick ;
	__property Ctl3D ;
	__property Dirtree::TDirTree* DirectoryTree = {read=FDirTree, write=SetFDirTree, nodefault};
	__property DragCursor ;
	__property DragMode ;
	__property bool DisplaySizeasKB = {read=FDisplaySizeasKB, write=SetDisplaySizeasKB, default=1};
	__property Stdctrls::TEdit* FileEdit = {read=FFileEdit, write=SetFileEdit, nodefault};
	__property TFileType FileType = {read=FFileType, write=SetFileType, default=64};
	__property ReadOnly ;
	__property Font ;
	__property THeaderType Header = {read=FHeader, write=SetHeader, default=13};
	__property HideSelection ;
	__property IconOptions ;
	__property System::AnsiString Mask = {read=FMask, write=SetMask, stored=IsMaskStored, nodefault};
	__property MultiSelect ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property bool ShowAtDesign = {read=FShowFiles, write=SetShowFiles, default=0};
	__property ShowColumnHeaders ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property ViewStyle ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnChange ;
	__property OnChanging ;
	__property OnColumnClick ;
	__property OnCompare ;
	__property OnDeletion ;
	__property OnEdited ;
	__property OnEditing ;
	__property OnEnter ;
	__property OnExit ;
	__property OnInsert ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnStartDrag ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
public:
	/* TWinControl.CreateParented */ __fastcall TFileListView(HWND ParentWindow) : Comctrls::TCustomListView(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class TFileType ;
template class THeaderType ;

}	/* namespace Tfilelistviewunit */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Tfilelistviewunit;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// TFileListViewUnit
